<?php
	###############################################################################################################################################################
	# Author:		Alexander Beyer
	# Copyright:	2010 by DevelopmentSuite
	# Contact:		Info@DevelopmentSuite.de
	#				++49 (89) 45 81 85 85
	# License:		Free for non-commercial use
	#				For commercial use please contact me
	# -------------------------------------------------------------------------------------------------------------------------------------------------------------
	# File: 		dsLogin ==> dsLogin.php
	# Version:		1.0.0
	# Last change:  10.12.2010
	###############################################################################################################################################################
	
	// Including of the function-file
	include 'dsLoginFunction.inc.php';


	if (isset($_GET['LOGOUT']))
	{
		// If including file is started with parameter LOGOUT (e.g. 'index.php?LOGOUT') the session will be ended
		if (DEBUGMODE)
		{
			echo 'LOGOUT';
		}
		Logout();
	}
	else if (isset($_POST['dsPassword']))
	{
		// If the login formular is send, try to log in
		if (DEBUGMODE)
		{
			echo 'LOGIN';
		}
		Login();
	}
	else
	{
		// If the including file is started without parameters, show formular
		if (DEBUGMODE)
		{
			echo 'SHOWFORM';
		}
		ShowLoginForm();
	}


	###############################################################################################################################################################
	# Functionname:	ShowLoginForm
	# Use:			Echos the HTML-Source necessary to create a login forular and shows the invalid login or expired session message when the
	#				start parameters are set.
	###############################################################################################################################################################
	function ShowLoginForm()
	{
		$loginid = '';
		if (isset($_GET[DSPARAM_LOGINID]) && isset($_GET[DSPARAM_LOGIN]))
		{
			// When these parameters are set, a message has to be shown
			if ($_GET[DSPARAM_LOGIN] == DSPARAMVAL_LOGIN_FAILED)
			{
				// The login failed
				$loginid = $_GET[DSPARAM_LOGINID];
				echo DSLANG_ERROR_WRONGLOGIN;
			}
			if ($_GET[DSPARAM_LOGIN] == DSPARAMVAL_LOGIN_EXPIRED)
			{
				// The session is expired
				$loginid = $_GET[DSPARAM_LOGINID];
				echo DSLANG_ERROR_EXPIRED;
			}
		}
		
		echo '<form name="dsLoginForm" method="post">';
		echo '    <table width="250" border="0" cellpadding="5" cellspacing="0">';
		if (JUSTPASSWORD != true)
		{
			// Echos the username field
			echo '    <tr>';
			echo '        <td width="106" align="right">'.DSLANG_USERNAME.':</td>';
			echo '        <td width="144"><input name="dsUserName" type="text" id="dsUserName" value="'.$loginid.'"></td>';
			echo '    </tr>';
		}
		echo '        <tr> ';
		echo '            <td align="right">'.DSLANG_PASSWORD.':</td>';
		echo '            <td><input name="dsPassword" type="password" id="dsPassword"></td>';
		echo '        </tr>';
		echo '        <tr align="center"> ';
		echo '            <td colspan="2"><input type="submit" name="dsSubmit" value="'.DSLANG_LOGIN.'"></td>';
		echo '        </tr>';
		echo '    </table>';
		echo '</form>';
	}
	
	###############################################################################################################################################################
	# Functionname:	Login
	# Use:			Varifies the login data, and if valid creates a session and redirects to the file set in the settings.
	#				If invalid the formular is shown again with a login failed message
	###############################################################################################################################################################
	function Login()
	{
		@session_start();
		
		if (JUSTPASSWORD != true)
		{
			// If JUSTPASSWORD is false, use the username form the field
			$loginid = $_POST['dsUserName'];
		}
		else
		{
			// If JUSTPASSWORD is true, use the standardusername
			$loginid = 'dsLOGINisSET';
		}
		$pw = $_POST['dsPassword'];
		
		$valid = false;
		
		if (DEBUGMODE)
		{
			echo '<p>Login-Password: '.$pw.'</p>';
			echo '<p>LOGININFORMATION: '.unserialize(LOGININFORMATION).'</p>';
		}
		if (JUSTPASSWORD == true)
		{
			if (DEBUGMODE)
			{
				echo '<p>JUSTPASSWORD: TRUE</p>';
			}
				// If JUSTPASSWORD is true, just check if password is correct
			if ($pw == unserialize(LOGININFORMATION))
		        $valid = true;
		}
		else
		{
			if (DEBUGMODE)
			{
				echo '<p>JUSTPASSWORD: FALSE</p>';
			}
			$users = unserialize(LOGININFORMATION);
			if (is_array($users))
			{
				if (DEBUGMODE)
				{
					echo '<p>LOGININFORMATION: IS ARRAY</p>';
				}
				// If JUSTPASSWORD is false and LOGININFORMATION is an array,
				// get the array item for the username from the field and check password
				if ($pw == $users[$loginid])
		        	$valid = true;
			}
			else
			{
				if (DEBUGMODE)
				{
					echo '<p>LOGININFORMATION: IS NO ARRAY</p>';
				}
			}
		}
			
		if ($valid == true)
		{
			// If Login was successfull, create a session and relocate to page set in the settings
			if (DEBUGMODE)
			{
				echo 'VALID PASSWORD';
			}
			session_register(SESSIONUSERNAME);
			$_SESSION[SESSIONUSERNAME] = $loginid;
			
			if (DEBUGMODE)
			{
				echo "<p>Login-User: ".$loginid."</p>";
				echo "<p>Login-Password: ".$pw."</p>";
				echo '<p>Relocate To: <a href="'.RELOCATEPAGE_LOGINSUCCESS.'">'.RELOCATEPAGE_LOGINSUCCESS.'</a></p>';
			}
			else
			{
				echo '<META HTTP-EQUIV="Refresh" CONTENT="0;URL='.RELOCATEPAGE_LOGINSUCCESS.'">'; 
			}
		}
		else
		{
			// If Login was not successfull, relocate to page set in the settings and ask for a new user/password
			$RefreshURL = CreatePageURLWithParameters(RELOCATEPAGE_LOGINCHECKFAILED, array(DSPARAM_LOGIN.'='.DSPARAMVAL_LOGIN_FAILED,
								   							 							   DSPARAM_LOGINID.'='.$loginid));
			if (DEBUGMODE)
			{
				echo "<p>Login-User: ".$loginid."</p>";
				echo 'Refresh to: '.$RefreshURL;
			}
			else
			{
				echo '<META HTTP-EQUIV="Refresh" CONTENT="0;URL='.$RefreshURL.'">';
			}
		}
	}
	
	###############################################################################################################################################################
	# Functionname:	Logout
	# Use:			Deletes the current login-session and relocates to the page set in the settings
	###############################################################################################################################################################
	function Logout()
	{
		@session_start();
		session_unset();
		@session_destroy();
		
		if (isset($HTTP_GET_VARS['setpage']))
		{
			echo '<META HTTP-EQUIV="Refresh" CONTENT="0;URL=../'.$HTTP_GET_VARS['setpage'].'">';
		}
		else
			echo '<META HTTP-EQUIV="Refresh" CONTENT="0;URL='.RELOCATEPAGE_LOGOUT.'">';
	}
?>