<?php
	###############################################################################################################################################################
	# Author:		Alexander Beyer
	# Copyright:	2010 by DevelopmentSuite
	# Contact:		Info@DevelopmentSuite.de
	#				++49 (89) 45 81 85 85
	# License:		Free for non-commercial use
	#				For commercial use please contact me
	# -------------------------------------------------------------------------------------------------------------------------------------------------------------
	# File: 		dsLogin ==> dsLoginFunction.inc.php
	# Version:		1.0.0
	# Last change:  09.12.2010
	###############################################################################################################################################################
	
	// Including of the settings-file
	include 'dsSettings.php';
	// Including of the language-file
	include $LANGUAGEFILE;
	
	###############################################################################################################################################################
	# Definition of the setting-variables as constants
	###############################################################################################################################################################
	define('DEBUGMODE', $DEBUGMODE);
	define('SESSIONUSERNAME', $SESSIONUSERNAME);
	
	define('RELOCATEPAGE_LOGINCHECKFAILED', $RELOCATEPAGE_LOGINCHECKFAILED);
	define('RELOCATEPAGE_LOGINSUCCESS', $RELOCATEPAGE_LOGINSUCCESS);
	define('RELOCATEPAGE_LOGOUT', $RELOCATEPAGE_LOGOUT);
	
	define('JUSTPASSWORD', $JUSTPASSWORD);
	define('LOGININFORMATION', serialize($LOGININFORMATION));

	define('DSPARAM_LOGINID', $DSPARAM_LOGINID);
	define('DSPARAM_LOGIN', $DSPARAM_LOGIN);
	define('DSPARAMVAL_LOGIN_FAILED', $DSPARAMVAL_LOGIN_FAILED);
	define('DSPARAMVAL_LOGIN_EXPIRED', $DSPARAMVAL_LOGIN_EXPIRED);

	###############################################################################################################################################################
	# Definition of the language-variables as constants
	###############################################################################################################################################################
	define('DSLANG_USERNAME', $DSLANG_USERNAME);
	define('DSLANG_PASSWORD', $DSLANG_PASSWORD);
	define('DSLANG_LOGIN', $DSLANG_LOGIN);
	define('DSLANG_ERROR_WRONGLOGIN', $DSLANG_ERROR_WRONGLOGIN);
	define('DSLANG_ERROR_EXPIRED', $DSLANG_ERROR_EXPIRED);


	###############################################################################################################################################################
	# Functionname:	ErrorHeader
	# Use:			Echos the HTML-Source necessary to create an empty page which redirects to another page
	# -------------------------------------------------------------------------------------------------------------------------------------------------------------
	# Parameters:	$pagename	-	filename of the file which shall be opened (e.g. 'index.php')
	#				$parameters	-	string (if one parameter) or array of the parameter (e.g. 'open=page1' or 'array('open=page1', 'read=page2')' )
	###############################################################################################################################################################
	function ErrorHeader($pagename, $parameters)
	{
		$RefreshURL = CreatePageURLWithParameters($pagename, $parameters);
		echo '<html>';
		echo '    <head>';
		echo '        <META HTTP-EQUIV="Refresh" CONTENT="0;URL='.$RefreshURL.'">';
		echo '    </head>';
		echo '    <body>';
		echo '    </body>';
		echo '</html>';
	}
	
	###############################################################################################################################################################
	# Functionname:	CheckLogin
	# Use:			Echos the HTML-Source necessary to create a table with the parameters as rows contents
	# -------------------------------------------------------------------------------------------------------------------------------------------------------------
	# Return:		bool, if the login is correct (true) or not (false)
	###############################################################################################################################################################
	function CheckLogin()
	{
		$result = false;
		@session_start();
		
		if (isset($_SESSION[SESSIONUSERNAME]))
		{
			if (trim($_SESSION[SESSIONUSERNAME]) != '')
			{
				global $loginid;
				$loginid = $_SESSION[SESSIONUSERNAME];
				
				$result = true;
			}
		}
		else
		{
			if (DEBUGMODE)
			{
				echo 'The session-variable "'.SESSIONUSERNAME.'" is not set.';
			}
		}
		return $result;
	}
	
	###############################################################################################################################################################
	# Functionname:	CreatePageURLWithParameters
	# Use:			Creates a URL-string of a file with starting parameters
	# -------------------------------------------------------------------------------------------------------------------------------------------------------------
	# Parameters:	$pagename	-	filename of the file which shall be opened (e.g. 'index.php')
	#				$parameters	-	string (if one parameter) or array of the parameter (e.g. 'open=page1' or 'array('open=page1', 'read=page2')' )
	# -------------------------------------------------------------------------------------------------------------------------------------------------------------
	# Return:		string which contains the full URL-string of the file including parameters (e.g. 'index.php?open=page1$read=page2')
	###############################################################################################################################################################
	function CreatePageURLWithParameters($pagename, $parameters)
	{
		$result = $pagename;
		
		if ((trim($parameters) == '') || ($parameters == null))
		{
			return $result;
		}
		else
		{
			$result .= '?';
			
			if (is_array($parameters))
			{
				$arraycount = count($parameters);
				if ($arraycount == 1)
				{
					$result .= $parameters[0];
				}
				else
				{
					for ($i = 0; $i < ($arraycount-1); $i++)
					{
						$result .= $parameters[$i].'&';
					}
					$result .= $parameters[$arraycount-1];
				}
			}
			else
			{
				$result .= $parameters;
			}
		}
		return $result;
	}
?>